#ifndef __MEM_H__
#define __MEM_H__


/* 1KB IVT */
#define IVT_START             0x00000000
#define IVT_END               0x00000400
/* 512B BIOS data area */
#define BIOS_DATA_START       0x00000400
#define BIOS_DATA_END         0x00000600
/* conventional memory */
#define LOW_MEM_START         0x00000600
#define LOW_MEM_END           0x0009fc00
/* BIOS extended data area */
#define BIOS_EXT_DATA_START   0x0009fc00
#define BIOS_EXT_DATA_END     0x000a0000
/* 128KB of VGA memory */
#define VGA_START             0x000a0000
#define VGA_END               0x000c0000
/* 192KB VGA BIOS rom */
#define VGA_BIOS_START        0x000c0000
#define VGA_BIOS_END          0x000f0000
/* 64KB BIOS rom */
#define BIOS_START            0x000f0000
#define BIOS_START_OFFSET     0x0000fff0
#define BIOS_END              0x00100000
/* Extended memory */
#define EXT_MEM_START         0x00100000

/*
** Functions
*/
struct mem_map;

struct mem_map* mem_init();


#endif
