#ifndef __PRINT_H__
#define __PRINT_H__

#include <types.h>

#define  MAX_PRINTF_BUFFER       1024

/*
** Compiler stubs for variadic functions
*/
#define  va_start(v,l)           __builtin_va_start(v,l)
#define  va_end(v)               __builtin_va_end(v)
#define  va_arg(v,l)             __builtin_va_arg(v,l)
typedef  __builtin_va_list       va_list;


/*
** Usable services
*/
size_t   printf(const char *format, ... );
size_t   snprintf(char *buff, size_t len, const char *format, ...);

/*
** Debug purpose
*/
//#define DEBUG 1

#ifdef DEBUG
#define  debug(format, ...) __debug(format, ## __VA_ARGS__ )
void     __debug(const char *format, ...);
#else
#define  debug(format, ...)
#endif

/*
** Internal usage
*/
size_t   vprintf(const char *format, va_list params );
size_t   vsnprintf(char *buffer, const size_t len, const char *format, va_list params );

#endif
