#include <mem.h>
#include <map.h>
#include <klibc.h>
#include <asmutils.h>


extern char __user_start__;
extern char __user_end__;
extern char __kernel_end__;

mem_map_t* mem_init()
{
   cr4_reg_t  cr4;
   cr3_reg_t  cr3;
   mem_map_t  *map;

   map = (mem_map_t*)&__kernel_end__;

   if( ! align((uint32_t)map,3) )
      map = (mem_map_t*)align_sup((uint32_t)map,3);

   memset( (void*)map, 0, sizeof(map) );
   memcpy( (void*)0, (void*)&__user_start__, (uint32_t)&__user_end__ - (uint32_t)&__user_start__ );

   /* fake cr4 (only vme is important) */
   cr4.raw.low = get_cr4();
   cr4.fields.vme = 1;
   cr4.fields.tsd = 1;
   cr4.fields.pse = 1;
   cr4.fields.mce = 1;
   cr4.fields.pge = 1;
   cr4.fields.pce = 1;

   /* fake cr3 */
   cr3.raw.low = 0;

   set_cr4( cr4 );
   set_cr3( cr3 );

   return map;
}
