#include <pic.h>
#include <irq.h>
#include <asmutils.h>


void pic_init()
{
   pic_icw1_t   icw1;
   pic_icw2_t   icw2;
   pic_icw3_t   icw3;
   pic_icw4_t   icw4;
   pic_ocw1_t   ocw1;

   icw1.raw = 0x11;
   out( icw1.raw, PIC_ICW1(PIC1) );
   out( icw1.raw, PIC_ICW1(PIC2) );

   icw2.raw = IRQ_MIN;
   out( icw2.raw, PIC_ICW2(PIC1) );

   icw2.raw = IRQ_MIN+8;
   out( icw2.raw, PIC_ICW2(PIC2) );

   icw3.raw = 0;
   icw3.m_fields.irq2 = 1;
   out( icw3.raw, PIC_ICW3(PIC1) );

   icw3.raw = 0;
   icw3.s_fields.slave_id = 2;
   out( icw3.raw, PIC_ICW3(PIC2) );

   icw4.raw = 1;
   out( icw4.raw, PIC_ICW4(PIC1) );
   out( icw4.raw, PIC_ICW4(PIC2) );

   ocw1.raw = 0xf9;
   out( ocw1.raw, PIC_IMR(PIC1) );

   ocw1.raw = 0xff;
   out( ocw1.raw, PIC_IMR(PIC2) );
}
