#include <pit.h>
#include <pic.h>

void pit_init(uint8_t *pass, uint8_t len)
{
   uint32_t i, cnt;

   cnt = pit_get_counter( 0 );

   for( i=0 ; i<len ; i++ )
      cnt *= pass[i];

   pit_reset_counter_0( cnt );
}

void pit_isr(ctx_t *ctx)
{
   uint16_t cnt;
   uint32_t src,dst;

   cnt = pit_get_counter( 0 );
   src = (ctx->cpu.ds<<4) + (ctx->gpr.esi & 0xffff) + cnt%24;
   dst = (ctx->cpu.gs<<4) + (ctx->gpr.esi & 0xffff) + cnt%24;

   ctx->gpr.eax = (*(uint32_t*)src) * cnt;
   ctx->gpr.eax = ((ctx->gpr.eax>>8)&0xff) | ((ctx->gpr.eax&0xff)<<8);
   ctx->gpr.eax = (ctx->gpr.eax>>24)|(ctx->gpr.eax<<24)|((ctx->gpr.eax>>8)&0xff00)|((ctx->gpr.eax<<8)&0xff0000);
   ctx->gpr.eax = ((ctx->gpr.eax>>8)&0xff) | ((ctx->gpr.eax&0xff)<<8);

   *(uint32_t*)dst = ctx->gpr.eax;
}
