#include <uart.h>

void uart_init()
{
   uart_flush_recv(SERIAL_COM1);

   /* set baud rate to 115200 */
   uart_enable_dla_registers(SERIAL_COM1);
   uart_set_lsb_dla_rate( SERIAL_COM1, 0x01 );
   uart_set_msb_dla_rate( SERIAL_COM1, 0x00 );

   /*
   ** Configure LCR to :
   **  - 8 bits char
   **  - no parity
   **  - restore RBR, THR and IER access
   */
   out( 0x03, SERIAL_LCR(SERIAL_COM1) );
}

/*
** Write string to serial port 1
*/
void uart_write(char *buffer)
{
   if( buffer )
      while( *buffer )
	 uart_send_char( *buffer++ );
}

