#include <klibc.h>

void* memset(void *dst, int c, size_t size)
{
   uint8_t *adst = (uint8_t*)dst;

   while( size )
   {
      *adst = (uint8_t)c;
      size --;
      adst ++;
   }

   return dst;
}

void* memcpy(void *dst, const void *src, size_t size)
{
   uint8_t *adst = (uint8_t*)dst;
   uint8_t *asrc = (uint8_t*)src;

   while( size-- )
      *adst++ = *asrc++;

   return dst;
}

void* memmove(void *dst, const void *src, size_t size)
{
   uint8_t *adst = (uint8_t*)dst;
   uint8_t *asrc = (uint8_t*)src;

   if( adst < asrc )
   {
      while( size )
      {
	 *adst = *asrc;
	 size --;
	 adst ++;
	 asrc ++;
      }
   }
   else
   {
      adst += size;
      asrc += size;
      while( size )
      {
	 *adst = *asrc;
	 size --;
	 adst --;
	 asrc --;
      }
   }

   return dst;
}
